diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv6-l3-protocol.cc ns-3.40/src/internet/model/ipv6-l3-protocol.cc
--- ns-3.39/src/internet/model/ipv6-l3-protocol.cc	2023-07-05 14:23:47.853427400 -0700
+++ ns-3.40/src/internet/model/ipv6-l3-protocol.cc	2023-09-27 13:30:37.658839200 -0700
@@ -150,14 +150,14 @@
     NS_LOG_FUNCTION(this);
 
     /* clear protocol and interface list */
-    for (L4List_t::iterator it = m_protocols.begin(); it != m_protocols.end(); ++it)
+    for (auto it = m_protocols.begin(); it != m_protocols.end(); ++it)
     {
         it->second = nullptr;
     }
     m_protocols.clear();
 
     /* remove interfaces */
-    for (Ipv6InterfaceList::iterator it = m_interfaces.begin(); it != m_interfaces.end(); ++it)
+    for (auto it = m_interfaces.begin(); it != m_interfaces.end(); ++it)
     {
         *it = nullptr;
     }
@@ -165,14 +165,14 @@
     m_reverseInterfacesContainer.clear();
 
     /* remove raw sockets */
-    for (SocketList::iterator it = m_sockets.begin(); it != m_sockets.end(); ++it)
+    for (auto it = m_sockets.begin(); it != m_sockets.end(); ++it)
     {
         *it = nullptr;
     }
     m_sockets.clear();
 
     /* remove list of prefix */
-    for (Ipv6AutoconfiguredPrefixListI it = m_prefixes.begin(); it != m_prefixes.end(); ++it)
+    for (auto it = m_prefixes.begin(); it != m_prefixes.end(); ++it)
     {
         (*it)->StopValidTimer();
         (*it)->StopPreferredTimer();
@@ -263,8 +263,7 @@
     NS_LOG_FUNCTION(this << address);
     int32_t index = 0;
 
-    for (Ipv6InterfaceList::const_iterator it = m_interfaces.begin(); it != m_interfaces.end();
-         it++)
+    for (auto it = m_interfaces.begin(); it != m_interfaces.end(); it++)
     {
         uint32_t j = 0;
         uint32_t max = (*it)->GetNAddresses();
@@ -287,8 +286,7 @@
     NS_LOG_FUNCTION(this << address << mask);
     int32_t index = 0;
 
-    for (Ipv6InterfaceList::const_iterator it = m_interfaces.begin(); it != m_interfaces.end();
-         it++)
+    for (auto it = m_interfaces.begin(); it != m_interfaces.end(); it++)
     {
         uint32_t j = 0;
         for (j = 0; j < (*it)->GetNAddresses(); j++)
@@ -316,7 +314,7 @@
 {
     NS_LOG_FUNCTION(this << device);
 
-    Ipv6InterfaceReverseContainer::const_iterator iter = m_reverseInterfacesContainer.find(device);
+    auto iter = m_reverseInterfacesContainer.find(device);
     if (iter != m_reverseInterfacesContainer.end())
     {
         return (*iter).second;
@@ -361,7 +359,7 @@
         address.SetOnLink(onLink);
 
         /* see if we have already the prefix */
-        for (Ipv6AutoconfiguredPrefixListI it = m_prefixes.begin(); it != m_prefixes.end(); ++it)
+        for (auto it = m_prefixes.begin(); it != m_prefixes.end(); ++it)
         {
             if ((*it)->GetInterface() == interface && (*it)->GetPrefix() == network &&
                 (*it)->GetMask() == mask)
@@ -421,7 +419,7 @@
     }
 
     /* remove from list of autoconfigured address */
-    for (Ipv6AutoconfiguredPrefixListI it = m_prefixes.begin(); it != m_prefixes.end(); ++it)
+    for (auto it = m_prefixes.begin(); it != m_prefixes.end(); ++it)
     {
         if ((*it)->GetInterface() == interface && (*it)->GetPrefix() == network &&
             (*it)->GetMask() == mask)
@@ -721,8 +719,7 @@
     NS_LOG_FUNCTION(this << forward);
     m_ipForward = forward;
 
-    for (Ipv6InterfaceList::const_iterator it = m_interfaces.begin(); it != m_interfaces.end();
-         it++)
+    for (auto it = m_interfaces.begin(); it != m_interfaces.end(); it++)
     {
         (*it)->SetForwarding(forward);
     }
@@ -823,7 +820,7 @@
     NS_LOG_FUNCTION(this << protocol);
 
     L4ListKey_t key = std::make_pair(protocol->GetProtocolNumber(), -1);
-    L4List_t::iterator iter = m_protocols.find(key);
+    auto iter = m_protocols.find(key);
     if (iter == m_protocols.end())
     {
         NS_LOG_WARN("Trying to remove an non-existent default protocol "
@@ -841,7 +838,7 @@
     NS_LOG_FUNCTION(this << protocol << interfaceIndex);
 
     L4ListKey_t key = std::make_pair(protocol->GetProtocolNumber(), interfaceIndex);
-    L4List_t::iterator iter = m_protocols.find(key);
+    auto iter = m_protocols.find(key);
     if (iter == m_protocols.end())
     {
         NS_LOG_WARN("Trying to remove an non-existent protocol "
@@ -867,21 +864,19 @@
 {
     NS_LOG_FUNCTION(this << protocolNumber << interfaceIndex);
 
-    L4ListKey_t key;
-    L4List_t::const_iterator i;
     if (interfaceIndex >= 0)
     {
         // try the interface-specific protocol.
-        key = std::make_pair(protocolNumber, interfaceIndex);
-        i = m_protocols.find(key);
+        auto key = std::make_pair(protocolNumber, interfaceIndex);
+        auto i = m_protocols.find(key);
         if (i != m_protocols.end())
         {
             return i->second;
         }
     }
     // try the generic protocol.
-    key = std::make_pair(protocolNumber, -1);
-    i = m_protocols.find(key);
+    auto key = std::make_pair(protocolNumber, -1);
+    auto i = m_protocols.find(key);
     if (i != m_protocols.end())
     {
         return i->second;
@@ -905,7 +900,7 @@
 {
     NS_LOG_FUNCTION(this << socket);
 
-    for (SocketList::iterator it = m_sockets.begin(); it != m_sockets.end(); ++it)
+    for (auto it = m_sockets.begin(); it != m_sockets.end(); ++it)
     {
         if ((*it) == socket)
         {
@@ -1089,8 +1084,7 @@
             // addresses. In doubt, update all of them. Note: it's a confirmed behavior for Linux
             // routers.
             std::list<NdiscCache::Entry*> entryList = ndiscCache->LookupInverse(from);
-            std::list<NdiscCache::Entry*>::iterator iter;
-            for (iter = entryList.begin(); iter != entryList.end(); iter++)
+            for (auto iter = entryList.begin(); iter != entryList.end(); iter++)
             {
                 (*iter)->UpdateReachableTimer();
             }
@@ -1098,7 +1092,7 @@
     }
 
     /* forward up to IPv6 raw sockets */
-    for (SocketList::iterator it = m_sockets.begin(); it != m_sockets.end(); ++it)
+    for (auto it = m_sockets.begin(); it != m_sockets.end(); ++it)
     {
         Ptr<Ipv6RawSocketImpl> socket = *it;
         socket->ForwardUp(packet, hdr, device);
@@ -1301,10 +1295,7 @@
             {
                 std::ostringstream oss;
 
-                for (std::list<Ipv6ExtensionFragment::Ipv6PayloadHeaderPair>::const_iterator it =
-                         fragments.begin();
-                     it != fragments.end();
-                     it++)
+                for (auto it = fragments.begin(); it != fragments.end(); it++)
                 {
                     CallTxTrace(it->second, it->first, this, interface);
                     outInterface->Send(it->first, it->second, route->GetGateway());
@@ -1332,10 +1323,7 @@
             {
                 std::ostringstream oss;
 
-                for (std::list<Ipv6ExtensionFragment::Ipv6PayloadHeaderPair>::const_iterator it =
-                         fragments.begin();
-                     it != fragments.end();
-                     it++)
+                for (auto it = fragments.begin(); it != fragments.end(); it++)
                 {
                     CallTxTrace(it->second, it->first, this, interface);
                     outInterface->Send(it->first, it->second, ipHeader.GetDestination());
@@ -1458,9 +1446,8 @@
     NS_LOG_LOGIC("Multicast forwarding logic for node: " << m_node->GetId());
 
     std::map<uint32_t, uint32_t> ttlMap = mrtentry->GetOutputTtlMap();
-    std::map<uint32_t, uint32_t>::iterator mapIter;
 
-    for (mapIter = ttlMap.begin(); mapIter != ttlMap.end(); mapIter++)
+    for (auto mapIter = ttlMap.begin(); mapIter != ttlMap.end(); mapIter++)
     {
         uint32_t interfaceId = mapIter->first;
         // uint32_t outputTtl = mapIter->second;  // Unused for now
@@ -1788,7 +1775,7 @@
     NS_LOG_FUNCTION(address << interface);
 
     Ipv6RegisteredMulticastAddressKey_t key = std::make_pair(address, interface);
-    Ipv6RegisteredMulticastAddressCIter_t iter = m_multicastAddresses.find(key);
+    auto iter = m_multicastAddresses.find(key);
 
     return iter != m_multicastAddresses.end();
 }
@@ -1798,8 +1785,7 @@
 {
     NS_LOG_FUNCTION(address);
 
-    Ipv6RegisteredMulticastAddressNoInterfaceCIter_t iter =
-        m_multicastAddressesNoInterface.find(address);
+    auto iter = m_multicastAddressesNoInterface.find(address);
 
     return iter != m_multicastAddressesNoInterface.end();
 }
@@ -1837,9 +1823,7 @@
         // we just confirm the entry's MAC address to get the waiting packets (if any)
         std::list<NdiscCache::Ipv6PayloadHeaderPair> waiting =
             entry->MarkReachable(entry->GetMacAddress());
-        for (std::list<NdiscCache::Ipv6PayloadHeaderPair>::const_iterator it = waiting.begin();
-             it != waiting.end();
-             it++)
+        for (auto it = waiting.begin(); it != waiting.end(); it++)
         {
             ndiscCache->GetInterface()->Send(it->first, it->second, it->second.GetSource());
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv6-l3-protocol.h ns-3.40/src/internet/model/ipv6-l3-protocol.h
--- ns-3.39/src/internet/model/ipv6-l3-protocol.h	2023-07-05 14:23:47.853427400 -0700
+++ ns-3.40/src/internet/model/ipv6-l3-protocol.h	2023-09-27 13:30:37.658839200 -0700
@@ -20,11 +20,12 @@
 #ifndef IPV6_L3_PROTOCOL_H
 #define IPV6_L3_PROTOCOL_H
 
+#include "ipv6-header.h"
+#include "ipv6-pmtu-cache.h"
+#include "ipv6-routing-protocol.h"
+#include "ipv6.h"
+
 #include "ns3/ipv6-address.h"
-#include "ns3/ipv6-header.h"
-#include "ns3/ipv6-pmtu-cache.h"
-#include "ns3/ipv6-routing-protocol.h"
-#include "ns3/ipv6.h"
 #include "ns3/net-device.h"
 #include "ns3/traced-callback.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv6-list-routing.cc ns-3.40/src/internet/model/ipv6-list-routing.cc
--- ns-3.39/src/internet/model/ipv6-list-routing.cc	2023-07-05 14:23:47.853427400 -0700
+++ ns-3.40/src/internet/model/ipv6-list-routing.cc	2023-09-27 13:30:37.658839200 -0700
@@ -57,8 +57,7 @@
 Ipv6ListRouting::DoDispose()
 {
     NS_LOG_FUNCTION(this);
-    for (Ipv6RoutingProtocolList::iterator rprotoIter = m_routingProtocols.begin();
-         rprotoIter != m_routingProtocols.end();
+    for (auto rprotoIter = m_routingProtocols.begin(); rprotoIter != m_routingProtocols.end();
          rprotoIter++)
     {
         // Note:  Calling dispose on these protocols causes memory leak
@@ -79,9 +78,7 @@
     NS_LOG_FUNCTION(this << header.GetDestination() << header.GetSource() << oif);
     Ptr<Ipv6Route> route;
 
-    for (Ipv6RoutingProtocolList::const_iterator i = m_routingProtocols.begin();
-         i != m_routingProtocols.end();
-         i++)
+    for (auto i = m_routingProtocols.begin(); i != m_routingProtocols.end(); i++)
     {
         NS_LOG_LOGIC("Checking protocol " << (*i).second->GetInstanceTypeId() << " with priority "
                                           << (*i).first);
@@ -131,8 +128,7 @@
     ErrorCallback nullEcb =
         MakeNullCallback<void, Ptr<const Packet>, const Ipv6Header&, Socket::SocketErrno>();
 
-    for (Ipv6RoutingProtocolList::const_iterator rprotoIter = m_routingProtocols.begin();
-         rprotoIter != m_routingProtocols.end();
+    for (auto rprotoIter = m_routingProtocols.begin(); rprotoIter != m_routingProtocols.end();
          rprotoIter++)
     {
         if ((*rprotoIter).second->RouteInput(p, header, idev, ucb, mcb, lcb, nullEcb))
@@ -150,8 +146,7 @@
 Ipv6ListRouting::NotifyInterfaceUp(uint32_t interface)
 {
     NS_LOG_FUNCTION(this << interface);
-    for (Ipv6RoutingProtocolList::const_iterator rprotoIter = m_routingProtocols.begin();
-         rprotoIter != m_routingProtocols.end();
+    for (auto rprotoIter = m_routingProtocols.begin(); rprotoIter != m_routingProtocols.end();
          rprotoIter++)
     {
         (*rprotoIter).second->NotifyInterfaceUp(interface);
@@ -162,8 +157,7 @@
 Ipv6ListRouting::NotifyInterfaceDown(uint32_t interface)
 {
     NS_LOG_FUNCTION(this << interface);
-    for (Ipv6RoutingProtocolList::const_iterator rprotoIter = m_routingProtocols.begin();
-         rprotoIter != m_routingProtocols.end();
+    for (auto rprotoIter = m_routingProtocols.begin(); rprotoIter != m_routingProtocols.end();
          rprotoIter++)
     {
         (*rprotoIter).second->NotifyInterfaceDown(interface);
@@ -174,8 +168,7 @@
 Ipv6ListRouting::NotifyAddAddress(uint32_t interface, Ipv6InterfaceAddress address)
 {
     NS_LOG_FUNCTION(this << interface << address);
-    for (Ipv6RoutingProtocolList::const_iterator rprotoIter = m_routingProtocols.begin();
-         rprotoIter != m_routingProtocols.end();
+    for (auto rprotoIter = m_routingProtocols.begin(); rprotoIter != m_routingProtocols.end();
          rprotoIter++)
     {
         (*rprotoIter).second->NotifyAddAddress(interface, address);
@@ -186,8 +179,7 @@
 Ipv6ListRouting::NotifyRemoveAddress(uint32_t interface, Ipv6InterfaceAddress address)
 {
     NS_LOG_FUNCTION(this << interface << address);
-    for (Ipv6RoutingProtocolList::const_iterator rprotoIter = m_routingProtocols.begin();
-         rprotoIter != m_routingProtocols.end();
+    for (auto rprotoIter = m_routingProtocols.begin(); rprotoIter != m_routingProtocols.end();
          rprotoIter++)
     {
         (*rprotoIter).second->NotifyRemoveAddress(interface, address);
@@ -202,8 +194,7 @@
                                 Ipv6Address prefixToUse)
 {
     NS_LOG_FUNCTION(this << dst << mask << nextHop << interface);
-    for (Ipv6RoutingProtocolList::const_iterator rprotoIter = m_routingProtocols.begin();
-         rprotoIter != m_routingProtocols.end();
+    for (auto rprotoIter = m_routingProtocols.begin(); rprotoIter != m_routingProtocols.end();
          rprotoIter++)
     {
         (*rprotoIter).second->NotifyAddRoute(dst, mask, nextHop, interface, prefixToUse);
@@ -218,8 +209,7 @@
                                    Ipv6Address prefixToUse)
 {
     NS_LOG_FUNCTION(this << dst << mask << nextHop << interface);
-    for (Ipv6RoutingProtocolList::const_iterator rprotoIter = m_routingProtocols.begin();
-         rprotoIter != m_routingProtocols.end();
+    for (auto rprotoIter = m_routingProtocols.begin(); rprotoIter != m_routingProtocols.end();
          rprotoIter++)
     {
         (*rprotoIter).second->NotifyRemoveRoute(dst, mask, nextHop, interface, prefixToUse);
@@ -235,9 +225,7 @@
                          << ", Time: " << Now().As(unit)
                          << ", Local time: " << m_ipv6->GetObject<Node>()->GetLocalTime().As(unit)
                          << ", Ipv6ListRouting table" << std::endl;
-    for (Ipv6RoutingProtocolList::const_iterator i = m_routingProtocols.begin();
-         i != m_routingProtocols.end();
-         i++)
+    for (auto i = m_routingProtocols.begin(); i != m_routingProtocols.end(); i++)
     {
         *stream->GetStream() << "  Priority: " << (*i).first
                              << " Protocol: " << (*i).second->GetInstanceTypeId() << std::endl;
@@ -250,8 +238,7 @@
 {
     NS_LOG_FUNCTION(this << ipv6);
     NS_ASSERT(!m_ipv6);
-    for (Ipv6RoutingProtocolList::const_iterator rprotoIter = m_routingProtocols.begin();
-         rprotoIter != m_routingProtocols.end();
+    for (auto rprotoIter = m_routingProtocols.begin(); rprotoIter != m_routingProtocols.end();
          rprotoIter++)
     {
         (*rprotoIter).second->SetIpv6(ipv6);
@@ -288,8 +275,7 @@
                                                                          << " out of range");
     }
     uint32_t i = 0;
-    for (Ipv6RoutingProtocolList::const_iterator rprotoIter = m_routingProtocols.begin();
-         rprotoIter != m_routingProtocols.end();
+    for (auto rprotoIter = m_routingProtocols.begin(); rprotoIter != m_routingProtocols.end();
          rprotoIter++, i++)
     {
         if (i == index)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv6-list-routing.h ns-3.40/src/internet/model/ipv6-list-routing.h
--- ns-3.39/src/internet/model/ipv6-list-routing.h	2023-07-05 14:23:47.853427400 -0700
+++ ns-3.40/src/internet/model/ipv6-list-routing.h	2023-09-27 13:30:37.658839200 -0700
@@ -18,7 +18,7 @@
 #ifndef IPV6_LIST_ROUTING_H
 #define IPV6_LIST_ROUTING_H
 
-#include "ns3/ipv6-routing-protocol.h"
+#include "ipv6-routing-protocol.h"
 
 #include <list>
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv6-option-demux.cc ns-3.40/src/internet/model/ipv6-option-demux.cc
--- ns-3.39/src/internet/model/ipv6-option-demux.cc	2023-07-05 14:23:47.853427400 -0700
+++ ns-3.40/src/internet/model/ipv6-option-demux.cc	2023-09-27 13:30:37.658839200 -0700
@@ -57,7 +57,7 @@
 void
 Ipv6OptionDemux::DoDispose()
 {
-    for (Ipv6OptionList_t::iterator it = m_options.begin(); it != m_options.end(); it++)
+    for (auto it = m_options.begin(); it != m_options.end(); it++)
     {
         (*it)->Dispose();
         *it = nullptr;
@@ -82,7 +82,7 @@
 Ptr<Ipv6Option>
 Ipv6OptionDemux::GetOption(int optionNumber)
 {
-    for (Ipv6OptionList_t::iterator i = m_options.begin(); i != m_options.end(); ++i)
+    for (auto i = m_options.begin(); i != m_options.end(); ++i)
     {
         if ((*i)->GetOptionNumber() == optionNumber)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv6-option.h ns-3.40/src/internet/model/ipv6-option.h
--- ns-3.39/src/internet/model/ipv6-option.h	2023-07-05 14:23:47.853427400 -0700
+++ ns-3.40/src/internet/model/ipv6-option.h	2023-09-27 13:30:37.658839200 -0700
@@ -20,11 +20,11 @@
 #ifndef IPV6_OPTION_H
 #define IPV6_OPTION_H
 
+#include "ipv6-header.h"
 #include "ipv6-interface.h"
 
 #include "ns3/buffer.h"
 #include "ns3/ipv6-address.h"
-#include "ns3/ipv6-header.h"
 #include "ns3/node.h"
 #include "ns3/object.h"
 #include "ns3/packet.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv6-packet-probe.h ns-3.40/src/internet/model/ipv6-packet-probe.h
--- ns-3.39/src/internet/model/ipv6-packet-probe.h	2023-07-05 14:23:47.853427400 -0700
+++ ns-3.40/src/internet/model/ipv6-packet-probe.h	2023-09-27 13:30:37.658839200 -0700
@@ -24,9 +24,10 @@
 #ifndef IPV6_PACKET_PROBE_H
 #define IPV6_PACKET_PROBE_H
 
+#include "ipv6.h"
+
 #include "ns3/boolean.h"
 #include "ns3/callback.h"
-#include "ns3/ipv6.h"
 #include "ns3/nstime.h"
 #include "ns3/object.h"
 #include "ns3/packet.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv6-pmtu-cache.cc ns-3.40/src/internet/model/ipv6-pmtu-cache.cc
--- ns-3.39/src/internet/model/ipv6-pmtu-cache.cc	2023-07-05 14:23:47.853427400 -0700
+++ ns-3.40/src/internet/model/ipv6-pmtu-cache.cc	2023-09-27 13:30:37.658839200 -0700
@@ -56,7 +56,7 @@
 void
 Ipv6PmtuCache::DoDispose()
 {
-    for (pathMtuTimerIter iter = m_pathMtuTimer.begin(); iter != m_pathMtuTimer.end(); iter++)
+    for (auto iter = m_pathMtuTimer.begin(); iter != m_pathMtuTimer.end(); iter++)
     {
         iter->second.Cancel();
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv6-raw-socket-factory-impl.h ns-3.40/src/internet/model/ipv6-raw-socket-factory-impl.h
--- ns-3.39/src/internet/model/ipv6-raw-socket-factory-impl.h	2023-07-05 14:23:47.853427400 -0700
+++ ns-3.40/src/internet/model/ipv6-raw-socket-factory-impl.h	2023-09-27 13:30:37.658839200 -0700
@@ -20,7 +20,7 @@
 #ifndef IPV6_RAW_SOCKET_FACTORY_IMPL_H
 #define IPV6_RAW_SOCKET_FACTORY_IMPL_H
 
-#include "ns3/ipv6-raw-socket-factory.h"
+#include "ipv6-raw-socket-factory.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv6-raw-socket-impl.cc ns-3.40/src/internet/model/ipv6-raw-socket-impl.cc
--- ns-3.39/src/internet/model/ipv6-raw-socket-impl.cc	2023-07-05 14:23:47.853427400 -0700
+++ ns-3.40/src/internet/model/ipv6-raw-socket-impl.cc	2023-09-27 13:30:37.658839200 -0700
@@ -293,7 +293,7 @@
                 p->CopyData(&type, sizeof(type));
                 if (type == Icmpv6Header::ICMPV6_ECHO_REQUEST)
                 {
-                    Icmpv6Echo hdr(1);
+                    Icmpv6Echo hdr(true);
                     p->RemoveHeader(hdr);
                     hdr.CalculatePseudoHeaderChecksum(route->GetSource(),
                                                       dst,
@@ -421,7 +421,7 @@
     NS_LOG_FUNCTION(this);
     uint32_t rx = 0;
 
-    for (std::list<Data>::const_iterator it = m_data.begin(); it != m_data.end(); ++it)
+    for (auto it = m_data.begin(); it != m_data.end(); ++it)
     {
         rx += (it->packet)->GetSize();
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv6-raw-socket-impl.h ns-3.40/src/internet/model/ipv6-raw-socket-impl.h
--- ns-3.39/src/internet/model/ipv6-raw-socket-impl.h	2023-07-05 14:23:47.853427400 -0700
+++ ns-3.40/src/internet/model/ipv6-raw-socket-impl.h	2023-09-27 13:30:37.658839200 -0700
@@ -20,8 +20,9 @@
 #ifndef IPV6_RAW_SOCKET_IMPL_H
 #define IPV6_RAW_SOCKET_IMPL_H
 
+#include "ipv6-header.h"
+
 #include "ns3/ipv6-address.h"
-#include "ns3/ipv6-header.h"
 #include "ns3/socket.h"
 
 #include <list>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv6-route.cc ns-3.40/src/internet/model/ipv6-route.cc
--- ns-3.39/src/internet/model/ipv6-route.cc	2023-07-05 14:23:47.853427400 -0700
+++ ns-3.40/src/internet/model/ipv6-route.cc	2023-09-27 13:30:37.658839200 -0700
@@ -141,8 +141,7 @@
     if (ttl >= MAX_TTL)
     {
         // This TTL value effectively disables the interface
-        std::map<uint32_t, uint32_t>::iterator iter;
-        iter = m_ttls.find(oif);
+        auto iter = m_ttls.find(oif);
         if (iter != m_ttls.end())
         {
             m_ttls.erase(iter);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv6-static-routing.cc ns-3.40/src/internet/model/ipv6-static-routing.cc
--- ns-3.39/src/internet/model/ipv6-static-routing.cc	2023-07-05 14:23:47.853427400 -0700
+++ ns-3.40/src/internet/model/ipv6-static-routing.cc	2023-09-27 13:30:37.658839200 -0700
@@ -181,7 +181,7 @@
 
     if (!LookupRoute(route, metric))
     {
-        Ipv6RoutingTableEntry* routePtr = new Ipv6RoutingTableEntry(route);
+        auto routePtr = new Ipv6RoutingTableEntry(route);
         m_networkRoutes.emplace_back(routePtr, metric);
     }
 }
@@ -208,7 +208,7 @@
                                                                               prefixToUse);
     if (!LookupRoute(route, metric))
     {
-        Ipv6RoutingTableEntry* routePtr = new Ipv6RoutingTableEntry(route);
+        auto routePtr = new Ipv6RoutingTableEntry(route);
         m_networkRoutes.emplace_back(routePtr, metric);
     }
 }
@@ -225,7 +225,7 @@
         Ipv6RoutingTableEntry::CreateNetworkRouteTo(network, networkPrefix, interface);
     if (!LookupRoute(route, metric))
     {
-        Ipv6RoutingTableEntry* routePtr = new Ipv6RoutingTableEntry(route);
+        auto routePtr = new Ipv6RoutingTableEntry(route);
         m_networkRoutes.emplace_back(routePtr, metric);
     }
 }
@@ -252,7 +252,7 @@
                                      std::vector<uint32_t> outputInterfaces)
 {
     NS_LOG_FUNCTION(this << origin << group << inputInterface);
-    Ipv6MulticastRoutingTableEntry* route = new Ipv6MulticastRoutingTableEntry();
+    auto route = new Ipv6MulticastRoutingTableEntry();
     *route = Ipv6MulticastRoutingTableEntry::CreateMulticastRoute(origin,
                                                                   group,
                                                                   inputInterface,
@@ -264,7 +264,7 @@
 Ipv6StaticRouting::SetDefaultMulticastRoute(uint32_t outputInterface)
 {
     NS_LOG_FUNCTION(this << outputInterface);
-    Ipv6RoutingTableEntry* route = new Ipv6RoutingTableEntry();
+    auto route = new Ipv6RoutingTableEntry();
     Ipv6Address network = Ipv6Address("ff00::"); /* RFC 3513 */
     Ipv6Prefix networkMask = Ipv6Prefix(8);
     *route = Ipv6RoutingTableEntry::CreateNetworkRouteTo(network, networkMask, outputInterface);
@@ -288,7 +288,7 @@
     if (index < m_multicastRoutes.size())
     {
         uint32_t tmp = 0;
-        for (MulticastRoutesCI i = m_multicastRoutes.begin(); i != m_multicastRoutes.end(); i++)
+        for (auto i = m_multicastRoutes.begin(); i != m_multicastRoutes.end(); i++)
         {
             if (tmp == index)
             {
@@ -306,7 +306,7 @@
                                         uint32_t inputInterface)
 {
     NS_LOG_FUNCTION(this << origin << group << inputInterface);
-    for (MulticastRoutesI i = m_multicastRoutes.begin(); i != m_multicastRoutes.end(); i++)
+    for (auto i = m_multicastRoutes.begin(); i != m_multicastRoutes.end(); i++)
     {
         Ipv6MulticastRoutingTableEntry* route = *i;
         if (origin == route->GetOrigin() && group == route->GetGroup() &&
@@ -326,7 +326,7 @@
     NS_LOG_FUNCTION(this << index);
     uint32_t tmp = 0;
 
-    for (MulticastRoutesI i = m_multicastRoutes.begin(); i != m_multicastRoutes.end(); i++)
+    for (auto i = m_multicastRoutes.begin(); i != m_multicastRoutes.end(); i++)
     {
         if (tmp == index)
         {
@@ -344,7 +344,7 @@
     NS_LOG_FUNCTION(this << network << interfaceIndex);
 
     /* in the network table */
-    for (NetworkRoutesI j = m_networkRoutes.begin(); j != m_networkRoutes.end(); j++)
+    for (auto j = m_networkRoutes.begin(); j != m_networkRoutes.end(); j++)
     {
         Ipv6RoutingTableEntry* rtentry = j->first;
         Ipv6Prefix prefix = rtentry->GetDestNetworkPrefix();
@@ -363,7 +363,7 @@
 bool
 Ipv6StaticRouting::LookupRoute(const Ipv6RoutingTableEntry& route, uint32_t metric)
 {
-    for (NetworkRoutesI j = m_networkRoutes.begin(); j != m_networkRoutes.end(); j++)
+    for (auto j = m_networkRoutes.begin(); j != m_networkRoutes.end(); j++)
     {
         Ipv6RoutingTableEntry* rtentry = j->first;
 
@@ -402,7 +402,7 @@
         return rtentry;
     }
 
-    for (NetworkRoutesI it = m_networkRoutes.begin(); it != m_networkRoutes.end(); it++)
+    for (auto it = m_networkRoutes.begin(); it != m_networkRoutes.end(); it++)
     {
         Ipv6RoutingTableEntry* j = it->first;
         uint32_t metric = it->second;
@@ -485,14 +485,13 @@
 {
     NS_LOG_FUNCTION(this);
 
-    for (NetworkRoutesI j = m_networkRoutes.begin(); j != m_networkRoutes.end();
-         j = m_networkRoutes.erase(j))
+    for (auto j = m_networkRoutes.begin(); j != m_networkRoutes.end(); j = m_networkRoutes.erase(j))
     {
         delete j->first;
     }
     m_networkRoutes.clear();
 
-    for (MulticastRoutesI i = m_multicastRoutes.begin(); i != m_multicastRoutes.end();
+    for (auto i = m_multicastRoutes.begin(); i != m_multicastRoutes.end();
          i = m_multicastRoutes.erase(i))
     {
         delete (*i);
@@ -509,7 +508,7 @@
     NS_LOG_FUNCTION(this << origin << group << interface);
     Ptr<Ipv6MulticastRoute> mrtentry = nullptr;
 
-    for (MulticastRoutesI i = m_multicastRoutes.begin(); i != m_multicastRoutes.end(); i++)
+    for (auto i = m_multicastRoutes.begin(); i != m_multicastRoutes.end(); i++)
     {
         Ipv6MulticastRoutingTableEntry* route = *i;
 
@@ -569,7 +568,7 @@
     uint32_t shortestMetric = 0xffffffff;
     Ipv6RoutingTableEntry* result = nullptr;
 
-    for (NetworkRoutesI it = m_networkRoutes.begin(); it != m_networkRoutes.end(); it++)
+    for (auto it = m_networkRoutes.begin(); it != m_networkRoutes.end(); it++)
     {
         Ipv6RoutingTableEntry* j = it->first;
         uint32_t metric = it->second;
@@ -606,7 +605,7 @@
     NS_LOG_FUNCTION(this << index);
     uint32_t tmp = 0;
 
-    for (NetworkRoutesCI it = m_networkRoutes.begin(); it != m_networkRoutes.end(); it++)
+    for (auto it = m_networkRoutes.begin(); it != m_networkRoutes.end(); it++)
     {
         if (tmp == index)
         {
@@ -625,7 +624,7 @@
     NS_LOG_FUNCTION(this << index);
     uint32_t tmp = 0;
 
-    for (NetworkRoutesCI it = m_networkRoutes.begin(); it != m_networkRoutes.end(); it++)
+    for (auto it = m_networkRoutes.begin(); it != m_networkRoutes.end(); it++)
     {
         if (tmp == index)
         {
@@ -644,7 +643,7 @@
     NS_LOG_FUNCTION(this << index);
     uint32_t tmp = 0;
 
-    for (NetworkRoutesI it = m_networkRoutes.begin(); it != m_networkRoutes.end(); it++)
+    for (auto it = m_networkRoutes.begin(); it != m_networkRoutes.end(); it++)
     {
         if (tmp == index)
         {
@@ -665,7 +664,7 @@
 {
     NS_LOG_FUNCTION(this << network << prefix << ifIndex);
 
-    for (NetworkRoutesI it = m_networkRoutes.begin(); it != m_networkRoutes.end(); it++)
+    for (auto it = m_networkRoutes.begin(); it != m_networkRoutes.end(); it++)
     {
         Ipv6RoutingTableEntry* rtentry = it->first;
         if (network == rtentry->GetDest() && rtentry->GetInterface() == ifIndex &&
@@ -809,7 +808,7 @@
     NS_LOG_FUNCTION(this << i);
 
     /* remove all static routes that are going through this interface */
-    for (NetworkRoutesI it = m_networkRoutes.begin(); it != m_networkRoutes.end();)
+    for (auto it = m_networkRoutes.begin(); it != m_networkRoutes.end();)
     {
         if (it->first->GetInterface() == i)
         {
@@ -845,7 +844,7 @@
 
     // Remove all static routes that are going through this interface
     // which reference this network
-    for (NetworkRoutesI it = m_networkRoutes.begin(); it != m_networkRoutes.end();)
+    for (auto it = m_networkRoutes.begin(); it != m_networkRoutes.end();)
     {
         if (it->first->GetInterface() == interface && it->first->IsNetwork() &&
             it->first->GetDestNetwork() == networkAddress &&
@@ -868,7 +867,7 @@
                                   uint32_t interface,
                                   Ipv6Address prefixToUse)
 {
-    NS_LOG_INFO(this << dst << mask << nextHop << interface << prefixToUse);
+    NS_LOG_FUNCTION(this << dst << mask << nextHop << interface << prefixToUse);
     if (nextHop == Ipv6Address::GetZero())
     {
         AddNetworkRouteTo(dst, mask, interface);
@@ -901,7 +900,7 @@
     NS_LOG_FUNCTION(this << dst << mask << nextHop << interface);
     if (dst != Ipv6Address::GetZero())
     {
-        for (NetworkRoutesI j = m_networkRoutes.begin(); j != m_networkRoutes.end();)
+        for (auto j = m_networkRoutes.begin(); j != m_networkRoutes.end();)
         {
             Ipv6RoutingTableEntry* rtentry = j->first;
             Ipv6Prefix prefix = rtentry->GetDestNetworkPrefix();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/model/ipv6-static-routing.h ns-3.40/src/internet/model/ipv6-static-routing.h
--- ns-3.39/src/internet/model/ipv6-static-routing.h	2023-07-05 14:23:47.853427400 -0700
+++ ns-3.40/src/internet/model/ipv6-static-routing.h	2023-09-27 13:30:37.658839200 -0700
@@ -20,10 +20,11 @@
 #ifndef IPV6_STATIC_ROUTING_H
 #define IPV6_STATIC_ROUTING_H
 
+#include "ipv6-header.h"
+#include "ipv6-routing-protocol.h"
+#include "ipv6.h"
+
 #include "ns3/ipv6-address.h"
-#include "ns3/ipv6-header.h"
-#include "ns3/ipv6-routing-protocol.h"
-#include "ns3/ipv6.h"
 #include "ns3/ptr.h"
 
 #include <list>
